r"""Select window

Copyright (C) GRISOFT, Inc.
"""

try:
	import sys
	import os
	import pygtk
	pygtk.require('2.0')
	import gtk
	import gtk.glade
	import sre
	import fsh
	import test
except Exception, detail:
	print detail
	sys.exit(1)

class CSelect:
	def __init__(self):
		self.__wTree = gtk.glade.XML("../glade/avggui.glade")
		self.__select_view = fsh.CView([os.path.expanduser("~")], False, True)
		self.__test = test.CTest()

		self.__select_window = self.__wTree.get_widget("wSelectObjects")
		self.__apply_button  = self.__wTree.get_widget("bApply")
		self.__start_button  = self.__wTree.get_widget("bStart")
		self.__cancel_button = self.__wTree.get_widget("bCancel")
		self.__select_scroll = self.__wTree.get_widget("swSelect")
		self.__paths_entry   = self.__wTree.get_widget("ePaths")

		self.__select_scroll.add(self.__select_view)

		self.__paths_entry.connect('activate', self.__entry_activate)
		self.__apply_button.connect('clicked', self.__new_selection)
		self.__cancel_button.connect('clicked', self.__cancel)
		self.__select_window.connect('delete-event', self.__delete)
		self.__start_button.connect('clicked', self.__start)

	def __new_selection(self, user_dat = None):
		pathnames_str = self.__paths_entry.get_text()
		pathnames_split = sre.split(";", pathnames_str)
		self.__select_view.init(pathnames_split, True, False, True)

	def __entry_activate(self, entry, user_param = None):
		self.__new_selection()
	
	def __cancel(self, user_data = None):
		self.__select_window.destroy()
		
	def __delete(self, widget, user_data = None):
		self.__select_window.destroy()

	def __start(self, user_data = None):
		self.__test.set_pathnames(self.__select_view.get_selected())
		self.__test.start()
		self.__select_window.destroy() 

	def show(self):
		self.__select_window.show_all()
		

if __name__ == "__main__":
	select = CSelect()
	select.show()
	gtk.gdk.threads_init()
	gtk.main()
