r"""Test window

Copyright (C) GRISOFT, Inc.
"""

try:
	from sys import exit
	import pygtk
	pygtk.require('2.0')
	import gtk
	import gtk.glade
	import scanner
	import os
	import sys
	import testresview
	import misc
except Exception, detail:
	print detail
	exit(1)

def CTest():
	"""CTest is a singleton. This functon returns handle to it."""

	if __CTest.instance == None:
		__CTest.instance = __CTest()

	return __CTest.instance

def clearCTest():
	__CTest.instance = None

class __CTest:

	instance = None

	def __init__(self):
		self.xpm = {
			'infected':
				["16 16 2 1",
			     "       c None",
			     "X      c #ff0000",
			     "                ",
			     "                ",
			     "                ",
			     "      XXXX      ",
			     "     XXXXXX     ",
			     "    XXXXXXXX    ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "    XXXXXXXX    ",
			     "     XXXXXX     ",
			     "      XXXX      ",
			     "                ",
			     "                ",
			     "                "],
			'clean':
				["16 16 2 1",
			     "       c None",
			     "X      c #00ff00",
			     "                ",
			     "                ",
			     "                ",
			     "      XXXX      ",
			     "     XXXXXX     ",
			     "    XXXXXXXX    ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "   XXXXXXXXXX   ",
			     "    XXXXXXXX    ",
			     "     XXXXXX     ",
			     "      XXXX      ",
			     "                ",
			     "                ",
			     "                "],

			'error':
				["16 16 2 1",
			     "       c None",
			     "X      c #ffaa00",
			     "                ",
			     "                ",
			     "                ",
			     "      XXXX      ",
			     "     XXXXXX     ",
			     "    XXXXXXXX    ",
			     "   XXXXXXXXXX   ",
			     "   XX      XX   ",
			     "   XX      XX   ",
			     "   XXXXXXXXXX   ",
			     "    XXXXXXXX    ",
			     "     XXXXXX     ",
			     "      XXXX      ",
			     "                ",
			     "                ",
			     "                "]
		}

		self.pixmap = {
			'infected': gtk.gdk.pixbuf_new_from_xpm_data(self.xpm['infected']),
			'error': gtk.gdk.pixbuf_new_from_xpm_data(self.xpm['error']),
			'clean': gtk.gdk.pixbuf_new_from_xpm_data(self.xpm['clean']),
		}
		
		wTree = gtk.glade.XML("../glade/avggui.glade")
		
		self.test_window      = wTree.get_widget("wTest")												# read widgets from glade project
		self.results_listview = wTree.get_widget("tResults")
		self.__adjustment = wTree.get_widget("swResults").get_vadjustment()
		self.stop_button      = wTree.get_widget("bStop")
		self.progress         = wTree.get_widget("statusbar")
		self.total_label      = wTree.get_widget("lTotal")
		self.infected_label   = wTree.get_widget("lInfected")
		self.errors_label     = wTree.get_widget("lErrors")

		self.stat_window         = wTree.get_widget("wTestStat")
		self.show_res_button     = wTree.get_widget("bTestStatShowRes")
		self.stat_close_button   = wTree.get_widget("bStatClose")
		self.stat_title_label    = wTree.get_widget("lStatTitle")
		self.stat_total_label    = wTree.get_widget("lStatTotal")
		self.stat_infected_label = wTree.get_widget("lStatInfected")
		self.stat_errors_label   = wTree.get_widget("lStatErrors")

		self.contextid = self.progress.get_context_id("progress")

		self.results_liststore = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)

		self.column_icon_name = gtk.TreeViewColumn("File")
		self.column_info      = gtk.TreeViewColumn("Result/Infection")
		self.column_obj       = gtk.TreeViewColumn("Path")
		
		self.column_icon_name.set_resizable(True)
		self.column_info.set_resizable(True)
		self.column_obj.set_resizable(True)

		self.renderer_icon = gtk.CellRendererPixbuf()													# CellRenderes
		self.renderer_name = gtk.CellRendererText()
		self.renderer_info = gtk.CellRendererText()
		self.renderer_obj  = gtk.CellRendererText()

		self.column_icon_name.set_property('min-width', 150)
		self.column_info.set_property('min-width', 150)
		self.renderer_name.set_property("width", 100)
		self.renderer_info.set_property("width", 100)

		self.column_icon_name.pack_start(self.renderer_icon, False)
		self.column_icon_name.pack_start(self.renderer_name, False)
		self.column_info.pack_start(self.renderer_info, False)
		self.column_obj.pack_start(self.renderer_obj, False)

		self.column_icon_name.add_attribute(self.renderer_icon, 'pixbuf', 0)
		self.column_icon_name.add_attribute(self.renderer_name, 'text', 1)
		self.column_info.add_attribute(self.renderer_info, 'text', 2)
		self.column_obj.add_attribute(self.renderer_obj, 'text', 3)

		self.results_listview.append_column(self.column_icon_name)
		self.results_listview.append_column(self.column_info)
		self.results_listview.append_column(self.column_obj)
		
		self.results_listview.set_model(self.results_liststore)	
		self.scanner = scanner.CScanner()

		# behavior of results TreeView - scrolling down or not 
		self.__scroll_down = True
		self.results_listview.connect('button_press_event', self.__set_scroll_down, False)
		#self.total_label.connect('button_press_event', self.__set_scroll_down, True)
		
		self.stop_button.connect('clicked', self.__stop_test)
		self.stat_close_button.connect('clicked', self.__stat_close)
		self.show_res_button.connect("clicked", self.__test_item_results_cb)
		self.stat_window.connect('delete_event', self.__stat_delete_event)
		self.test_window.connect('delete_event', self.__test_delete_event)

	def __set_scroll_down(self, widget, event, value=True):
		self.__scroll_down = value
	
	def __test_statistic(self, title, total, infected, errors):
		self.scanner.disconnect('progress', self.__print_progress)											# unregister callbacks
		self.scanner.disconnect('obj-total', self.__print_total)
		self.scanner.disconnect('obj-infected', self.__print_infected)
		self.scanner.disconnect('obj-error', self.__print_errors)
		self.scanner.disconnect('infected', self.__infected)
		self.scanner.disconnect('clean', self.__clean)
		self.scanner.disconnect('error', self.__error)
		self.scanner.disconnect('failed', self.__test_terminated)
		self.scanner.disconnect('terminated', self.__test_terminated)
		self.scanner.disconnect('finished', self.__test_finished)

		self.test_window.destroy()
		self.stat_title_label.set_label(title)
		self.stat_total_label.set_label(str(total))
		
		if infected:
			self.stat_title_label.set_label('<span foreground="red" size="xx-large"><b>VIRUS FOUND</b></span>')
			self.stat_infected_label.set_label('<span foreground="red"><b>' + str(infected) + '</b></span>')
		else:
			self.stat_infected_label.set_label(str(infected))
			
		if errors:
			self.stat_errors_label.set_label('<span foreground="#f707ef"><b>' + str(errors) + '</b></span>')
		else:
			self.stat_errors_label.set_label(str(errors))
		
		self.stat_window.show()
		return	

	def __stat_close(self, user_data = None):
		self.stat_window.destroy()
		clearCTest()
		return

	def __test_item_results_cb(self, widget, data = None):
		test_res_window = testresview.CAvgGuiTestResultsView()
		self.stat_window.destroy()
		clearCTest()
		test_res_window.update()
		test_res_window.show()
		test_res_window.view_last_result()

	def __test_delete_event(self, widget, event, data = None):
		self.scanner.stop()
		return 

	def __stat_delete_event(self, widget, event, data = None):
		self.stat_window.destroy()
		return
		
	def __test_terminated(self, total, infected, errors):
		self.__test_statistic('<span foreground="#0000aa" size="xx-large"><b>INTERRUPTED</b></span>', total, infected, errors)
		return 

	def __test_finished(self, total, infected, errors):
		self.__test_statistic('<span foreground="#0000aa" size="xx-large"><b>FINISHED</b></span>', total, infected, errors)
		return
		
	def __infected(self, obj, info):
		uobj = misc.filename_to_utf8(obj)
		self.results_liststore.append([self.pixmap['infected'],  os.path.basename(uobj), info, uobj])
		self.__scroll_to_bottom()
		return

	def __error(self, obj, error):
		uobj = misc.filename_to_utf8(obj)
		self.results_liststore.append([self.pixmap['error'], os.path.basename(uobj), error, uobj])
		self.__scroll_to_bottom()
		return

	def __clean(self, obj):
		uobj = misc.filename_to_utf8(obj)
		self.results_liststore.append([self.pixmap['clean'], os.path.basename(uobj), "clean", uobj])
		self.__scroll_to_bottom()
		return

	def __scroll_to_bottom(self):
		if self.__adjustment.value == self.__adjustment.upper - self.__adjustment.page_size:
			self.__scroll_down = True
		if self.__scroll_down:
			self.__adjustment.set_value(self.__adjustment.upper - self.__adjustment.page_size)

	def __print_progress(self, obj):
		uobj = misc.filename_to_utf8(obj)
		self.progress.pop(self.contextid)
		self.progress.push(self.contextid, uobj)
		return
	
	def __print_total(self, num):
		self.total_label.set_label(str(num))
		return

	def __print_infected(self, num):
		self.infected_label.set_label('<span foreground="red"><b>' + str(num) +  '</b></span>')
		return

	def __print_errors(self, num):
		self.errors_label.set_label('<span foreground="#f707ef"><b>' + str(num) +  '</b></span>')
		return

	def __stop_test(self, user_data = None):
		self.scanner.stop()
		return

	def set_pathnames(self, pathnames):
		self.scanner.set_pathnames(pathnames)
		return

	def start(self):
		"""Start test and show test progress."""

		if self.instance != None:
			if self.test_window:
				self.test_window.present()
			else:	
				self.stat_window.present()
		
		self.scanner.connect('progress', self.__print_progress)											# register callbacks
		self.scanner.connect('obj-total', self.__print_total)
		self.scanner.connect('obj-infected', self.__print_infected)
		self.scanner.connect('obj-error', self.__print_errors)
		self.scanner.connect('infected', self.__infected)
		self.scanner.connect('clean', self.__clean)
		self.scanner.connect('error', self.__error)
		self.scanner.connect('failed', self.__test_terminated)
		self.scanner.connect('terminated', self.__test_terminated)
		self.scanner.connect('finished', self.__test_finished)

		self.test_window.show_all()
		self.scanner.start()

		return

if __name__ == "__main__":
	test = CTest()
	gtk.gdk.threads_init()
	gtk.main()
